<?php
include_once($_SERVER['DOCUMENT_ROOT'].'/wp-load.php' );

function strip_to_alpha_only($string)
{
     $pattern = '/[^a-zA-Z]/';
     return preg_replace($pattern, '', $string);
}

if (isset($_GET['quick']) && ($_GET['quick'] == 'true')) {
    if (isset($_GET['post'])) {
        $export_posts_tag = get_option('export_posts_tag');
        $post = get_post($_GET['post']);
        $user = get_user_by('id', $post->post_author);

        $tag = get_cached_post_tag_by_name($export_posts_tag);
        wp_set_object_terms($post->ID, $tag->name, 'post_tag', True);
        clean_post_cache($post->ID);
        # add export-posts-date meta
        update_post_meta($post->ID, 'export-posts-date', date('Y-m-d'));
        update_post_meta($post->ID, 'e_section_status', 'printed');

        $xml_title = htmlspecialchars($post->post_title);
        $xml .= "<". strtolower(strip_to_alpha_only($post->post_title)) .">\n";
        $xml .= "<title>". $xml_title . "</title>\n";
        $xml .= "<author>". $user->display_name . "</author>\n";
        $content = strip_tags($post->post_content, '<b><i><strong><em>');
        $content = preg_replace("/&nbsp;/", "", $content);

        $xml .= "<content>". $content . "\t\t</content>\n";
        $xml .= "</". strtolower(strip_to_alpha_only($post->post_title)) .">\n";

        $filename = strtolower(strip_to_alpha_only($post->post_title)) . ".xml";

        header("Content-type: text/xml");
        header('Content-Disposition: attachment; filename=' . $filename);
        print $xml;
        // print_r($post);
        exit();
    }
}
header("HTTP/1.0 403 Forbidden");
?>