<?php
class reader_report {


    function view() {
        if (!$_GET['date']) { $date = date("Y-m-d", strtotime('yesterday')); } else { $date = $_GET['date']; }
        $option_name = 'e_section_tracker_' . date("mdY", strtotime($date));
        $tracks = unserialize(get_option($option_name));
        $total = (isset($tracks['total']) ? $tracks['total'] : 0);
        $page_total = 0;
        if ($tracks) {
            foreach ($tracks as $key => $value) {
                if ($key == 'total') { continue; }
                if (preg_match_all('/^[A-D](\d+)/', $key, $matches) == 0) { continue; }
                $page_total += $value;
            }
            $track_keys = array_keys($tracks);
            natsort($track_keys);

        } else { $track_keys = Array(); }

        $edition_opt_name = 'e_section_edition_tracker_' . date("mdY", strtotime($date));
        $edition_tracks = unserialize(get_option($edition_opt_name));
        $edition_total = (isset($edition_tracks['total']) ? $edition_tracks['total'] : 0);
        $edition_page_total = 0;
        if ($edition_tracks) {
            foreach ($edition_tracks as $key => $value) {
                if ($key == 'total') { continue; }
                if (preg_match_all('/^[A-D](\d+)/', $key, $matches) == 0) { continue; }
                $edition_page_total += $value;
            }
            $edition_keys = array_keys($edition_tracks);
            natsort($edition_keys);
        }
        ?>
            <div class="wrap" id="e-section-wrap">
                <div id="e-section-title">
                    <h2>E-Section - Readership Report</h2>
                </div>
            </div>
            <div class="wrap">
                <form method="GET">
                    Date: <input type="text" name="date" value="<?php echo $date; ?>" class="date-pick"/>
                    <input type="hidden" name="page" value="e-section-reader-report"/>
                    <input type="submit"/>
                </form>
            </div>
        <?php

        // $distribution = $this->get_distribution($date);
        // $total_distribution = $this->get_total_distribution($date);
        $circulation = $this->get_circulation();
        // print $distribution . ", " . $circulation . "</br>";
        $rows = $this->get_pages($date);
        // $columns = array_chunk(($rows), (count($rows)/3)+1);

        // $section_distribution = 0;
        // foreach ($distribution as $row) {
        //     $section_distribution += intval($row['visitors']);
        // }
        //
        $inventory = 0;

        foreach ($track_keys as $key) {
            if ($key == 'total') { continue; }
            if (preg_match_all('/^([A-D])(\d+)/', $key, $matches) == 0) { continue; }
                        // print "<pre>"; print $matches[2][0]; print "</pre>";
            $section = $matches[1][0];
            if ($matches[2][0] == 1) { $paired_section = $section.$matches[2][0]; }
            elseif ($matches[2][0] % 2 == 0) { $paired_section = $section.($matches[2][0] + 1); }
            else { $paired_section = $section.($matches[2][0] - 1); }
            $visitors = intval($tracks[$key]);
            $readership = ($circulation * ($visitors/$total)) + $visitors;


            if (isset($edition_tracks[$key])) {
                $edition_visitors = intval($edition_tracks[$key]);
                $edition_readership = ($circulation * ($edition_visitors/$edition_total)) + $edition_visitors;
                if ($key == $paired_section) {
                    $inventory += intval($edition_visitors+$circulation);
                } else {
                    $paired_edition_visitors = intval($edition_tracks[$paired_section]);
                    $paired_edition_readership = ($circulation * ($paired_edition_visitors/$edition_total)) + $paired_edition_visitors;
                    $served = (round($edition_readership) + round($paired_edition_readership)) - $paired_edition_visitors;
                    $inventory += intval($served);
                }
            }
        }



        print '<div id="e_section_log_results" style="margin: auto;">';
        print "<table style=\"margin: 20px 50px;\">\n";
        print "<tr>\n";
        print "<th style=\"text-align: left;\">Date:</th>\n<td>" . $date . "</td>\n";
        print "</tr>\n";
        print "<tr>\n";
        print "<th style=\"text-align: left;\">Print Circulation:</th>\n<td>" . $circulation . "</td>\n";
        print "</tr>\n";
        print "<tr>\n";
        print "<th style=\"text-align: left;\">Readers of this Edition:</th>\n<td>" . $edition_total . "</td>\n";
        print "</tr>\n";
        print "<tr>\n";
        print "<!-- <th style=\"text-align: left;\">Edition Page Views:</th>\n<td>" . $edition_page_total . "</td> -->\n";
        print "</tr>\n";
        print "<tr>\n";
        print "<th style=\"text-align: left;\">Other Readers Today:</th>\n<td>" . ($total-$edition_total) . "</td>\n";
        print "</tr>\n";
        print "<tr>\n";
        print "<th style=\"text-align: left;\">Reader Inventory:</th>\n<td>" . $inventory . "</td>\n";
        print "</tr>\n";
        print "</table>\n";

        if ($tracks) {
            print "<table style='width: 700px;'>\n";
            print "<tr>\n";
            print "<th>Page</th>\n";
            print "<th>Print+Digital<br/>Readership</th>\n";
            print "<th>Individual<br/>Pages Only</th>\n";
            print "<th>Digital<br/>Only</th>\n";
            // print "<th>Combined</br>Readership</th>\n";
            print "<th>Out of</br>Edition</th>\n";
            print "</tr>\n";


            foreach ($track_keys as $key) {
                if ($key == 'total') { continue; }
                if (preg_match_all('/^([A-D])(\d+)/', $key, $matches) == 0) { continue; }
                // print "<pre>"; print $matches[2][0]; print "</pre>";
                $section = $matches[1][0];
                if ($matches[2][0] == 1) { $paired_section = $section.$matches[2][0]; }
                elseif ($matches[2][0] % 2 == 0) { $paired_section = $section.($matches[2][0] + 1); }
                else { $paired_section = $section.($matches[2][0] - 1); }
                $visitors = intval($tracks[$key]);
                $readership = ($circulation * ($visitors/$total)) + $visitors;
                print "<tr style=\"text-align: center;\">\n";
                print "<td width=\"20%\">" . $key . "</td>\n";

                if (isset($edition_tracks[$key])) {
                    $edition_visitors = intval($edition_tracks[$key]);
                    $edition_readership = ($circulation * ($edition_visitors/$edition_total)) + $edition_visitors;
                    if ($key == $paired_section) { print "<td width\"20%\">" . ($edition_visitors+$circulation) . "</td>\n"; }
                    else {
                        print "<td>";
                        $paired_edition_visitors = intval($edition_tracks[$paired_section]);
                        $paired_edition_readership = ($circulation * ($paired_edition_visitors/$edition_total)) + $paired_edition_visitors;
                        $served = (round($edition_readership) + round($paired_edition_readership)) - $paired_edition_visitors;
                        // print "pev: " . $paired_edition_visitors . "</br>";
                        // print "per: " . round($paired_edition_readership) . "</br>";
                        // print round($edition_readership) . "+" . round($paired_edition_readership) . "-" . $paired_edition_visitors . "=" . $served;
                        print $served;
                        print "</td>";
                    }
                    print "<td width=\"20%\">" . round($edition_readership) . "</td>\n";
                    print "<td width=\"20%\">" . $edition_visitors . "</td>\n";
                } else {
                    print "<td width=\"20%\">&nbsp;</td>\n";
                    print "<td width=\"20%\">&nbsp;</td>\n";
                    print "<td width=\"20%\">&nbsp;</td>\n";
                }
                // print "<td width=\"20%\">" . round($readership) . "</td>\n";
                print "<td width=\"20%\">" . $tracks[$key] . "</td>\n";
                print "</tr>\n";
            }
            print "</table>\n</div>";
        } else {
            print "<h3>No Data</h3>\n";
        }
        ?>
        <script type="text/javascript" charset="utf-8">
    jQuery(document).ready(function($) {
        $('.date-pick')
                    .datepicker({
                        dateFormat: 'yy-mm-dd',
                        maxDate: '-1d'
                    });
    });
</script>
<?php
    }

    function get_circulation() {
        $circulation = get_option('akwt_distribution_circulation', 0);
        return $circulation;
    }

    function get_distribution($date="") {
        $siteurl = get_option('siteurl', False);

        if ($siteurl == 'http://www.dailyrepublic.com') {
            $disturl = 'http://www.newspaperfoundation.org/distribution2/dr-esection.php';
        } elseif ($siteurl == 'http://www.davisenterprise.com') {
            $disturl = 'http://www.newspaperfoundation.org/distribution2/de-esection.php';
        } else {
            $disturl = False;
        }
        if ($disturl) {
            if ($date) {
                $disturl = $disturl . "?startDate=" . $date . "&endDate=" . $date;
            }
            $json = file_get_contents($disturl);
            $data = json_decode($json, TRUE);
            return $data['distribution'];
        }
        return 0;
    }

    function get_total_distribution($date="") {
        $siteurl = get_option('siteurl', False);

        if ($siteurl == 'http://www.dailyrepublic.com') {
            $disturl = 'http://www.newspaperfoundation.org/distribution2/dr.php';
        } elseif ($siteurl == 'http://www.davisenterprise.com') {
            $disturl = 'http://www.newspaperfoundation.org/distribution2/de.php';
        } else {
            $disturl = False;
        }
        if ($disturl) {
            if ($date) {
                $disturl = $disturl . "?startDate=" . $date . "&endDate=" . $date;
            }
            $json = file_get_contents($disturl);
            $data = json_decode($json, TRUE);
            return $data['distribution'];
        }
        return 0;
    }

    function get_pages($date="") {
        global $wpdb;
        $table_name = $wpdb->prefix . "e_section";


        $sql = "SELECT section, page, COUNT(id) AS c FROM " . $table_name;
        $sql .= " WHERE date(ts) = date('" . $date . "')";
        $sql .= " GROUP BY section, page HAVING COUNT(id) > 0 ORDER BY CHAR_LENGTH(section), section, page";
        $rows = $wpdb->get_results($sql);
        return $rows;
    }
}
?>

